/* 
Wicket - dodgy Java IRC bot
Copyright Mat Grove, 2004, http://www.matthewgrove.co.uk/

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation.

*/
package uk.ac.port.dsg.wicket;

import org.jibble.pircbot.*;
import java.util.*;

public class CricketBot extends PircBot {

	private CricketBot bot;
	private HashMap Brains = new HashMap();

	private static void crapWait(int secs) {
		long wait = secs * 1000;
		long start = System.currentTimeMillis();
		long now = 0;
		while (now < (start + wait)) {
			now = System.currentTimeMillis();
		}
	}

	public CricketBot() {
		bot = this;

		bot.setLogin("CB");
		bot.setName("Wicket");
		// Enable debugging output.
		//bot.setVerbose(true);

		// Connect to the IRC server.

		try {
			try {
				bot.connect("irc.blitzed.org");
			} catch (NickAlreadyInUseException e) {
				bot.setName("Wicket-regain");
				bot.connect("irc.blitzed.org");
			}
		} catch (Exception fe) {
			System.out.println("Cant connect - dead");
			System.out.println(fe);
			fe.printStackTrace();
			System.exit(0);
		}

	}

	public void printMessage(String target, String action) {
		sendMessage(target, action);
	}

	public void printAction(String target, String action) {
		sendAction(target, action);
	}

	public void onFinger(String sourceNick, String sourceLogin, String sourceHostname, String target) {
		//sendAction(channel, "bites " + sourceNick + "s finger off");
	}

	public void onPing(String sourceNick, String sourceLogin, String sourceHostname, String target, String pingValue) {
		//sendAction(channel, "sits on the ICMP packet from " + sourceNick);
	}

	public void onKick(String channel, String kickerNick, String kickerLogin, String kickerHostname, String recipientNick, String reason) {
		if (recipientNick.equalsIgnoreCase(getNick())) {
			joinChannel(channel);
		} else {
			sendAction(channel, "hisses at " + recipientNick);
		}
	}

	public void onConnect() {
		bot.setMessageDelay(10);
		if (bot.getName().equalsIgnoreCase("Wicket-regain")) {
			sendMessage("nickserv", "regain Wicket ??????");
		} else {
			sendMessage("nickserv", "identify ??????");
		}

        addBrain("#hants");
        addBrain("#dorset");
		addBrain("#wicket2");
		

	}

	private void addBrain(String chan) {
		bot.joinChannel(chan);
		Brain w = new Brain(bot, chan);
		Brains.put(chan, w);
		w.start();
	}

	private Brain findBrain(String channel) {
		return (Brain) Brains.get(channel);
	}

	public void onUserList(String channel, User[] users) {
		//System.out.println("onUserList");
	}

	public void onInvite(String targetNick, String sourceNick, String sourceLogin, String sourceHostname, String channel) {
		Brain wicket = findBrain(channel);
		if (!wicket.isOp(sourceNick)) {
			System.out.println("Invite from " + sourceNick + " (" + channel + ")");
			wicket.banKick(sourceHostname, sourceLogin, sourceNick, "Wicket doesn't like being invited!");
		} else {
			System.out.println("Invite from an op " + sourceNick + " (" + channel + ")");
		}
	}

	public void onOp(String channel, String sourceNick, String sourceLogin, String sourceHostname, String recipient) {
		if (!recipient.equalsIgnoreCase(bot.getNick())) {
			sendAction(channel, "rubs up against " + recipient);
		} else {
			sendAction(channel, "rubs up against " + sourceNick + " and purrs");
		}
	}

	public void onVoice(String channel, String sourceNick, String sourceLogin, String sourceHostname, String recipient) {
		if (!recipient.equalsIgnoreCase(getNick())) {
			sendAction(channel, "meows at " + recipient);
		}
	}

	public void onDeop(String channel, String sourceNick, String sourceLogin, String sourceHostname, String recipient) {
		if (recipient.equalsIgnoreCase(bot.getNick())) {
			sendMessage("chanserv", "op " + channel + " Wicket");
		}
	}

	public void onServerResponse(int code, String response) {
		System.out.println(code);
		//System.out.println(" onServerResponse: " + response);
	}

	public void onNickChange(String oldNick, String login, String hostname, String newNick) {

	}

	private void brainBroadcast(int type, String sender, String login, String hostname, String message) {
		Collection c = Brains.values();
		for (Iterator it = c.iterator(); it.hasNext();) {
			Brain b = (Brain) it.next();
			System.out.println("Broadcasting to " + b.getChannel());
			b.command(type, sender, login, hostname, message);
		}
	}

	public void onPrivateMessage(String sender, String login, String hostname, String message) { // private message is probably spam
		brainBroadcast(Brain.MP, sender, login, hostname, message);
	}

	public void onAction(String sender, String login, String hostname, String target, String action) {
		Brain wicket = findBrain(target);
		if (wicket != null) {
			wicket.command(Brain.MA, sender, login, hostname, action);
		} else {
			System.out.println("An action was performed on a nick rather than a channel");
		}
	}

	public void onMessage(String channel, String sender, String login, String hostname, String message) {
		//System.out.println("Finding " + channel + " brain");
		Brain wicket = findBrain(channel);
		wicket.command(Brain.MB, sender, login, hostname, message);
	}

	public void onPart(String channel, String sender, String login, String hostname) {
		Brain wicket = findBrain(channel);
		if (sender.equalsIgnoreCase(bot.getNick())) {
			//
		} else {
			wicket.command(Brain.PART, sender, login, hostname, "");
		}
	}

	public void onJoin(String channel, String sender, String login, String hostname) {
		Brain wicket = findBrain(channel);
		if (sender.equalsIgnoreCase(bot.getNick())) {
			sendMessage("chanserv", "op " + channel + " Wicket");
		} else {
			wicket.command(Brain.JOIN, sender, login, hostname, "");
		}
	}

}
