/* 
Wicket - dodgy Java IRC bot
Copyright Mat Grove, 2004, http://www.matthewgrove.co.uk/

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation.

*/
package uk.ac.port.dsg.wicket.plugins.gatekeeper;

import uk.ac.port.dsg.wicket.Brain;
import uk.ac.port.dsg.wicket.plugins.BrainInterface;
import org.jibble.pircbot.*;
import java.util.*;
import java.io.*;

public class WicketPlugin extends BrainInterface {

	private class Bouncer {
		private long firstBounce;
		private int totalBounces;
		private String nick;

		private final int TRACKMINS = 15;
		private long trackTime;

		public Bouncer(String looser) {
			trackTime = TRACKMINS * 60 * 1000;

			nick = looser;
			firstBounce = System.currentTimeMillis();
			totalBounces++;
		}

		public int bounce() {
			if ((firstBounce + trackTime) > System.currentTimeMillis()) {
				totalBounces++;
				System.out.println("Extra bounce");
			} else {
				totalBounces = 1;
				firstBounce = System.currentTimeMillis();
				System.out.println("Bouncing reset");
			}

			return totalBounces;
		}

	}

	private HashMap joiners = new HashMap();
	private HashMap bouncers = new HashMap();

	public WicketPlugin(Brain irc) {
		super(irc);
	}

	public int getImportance() {
		return 20;
	}

	public boolean doMessage(int type, String sender, String login, String hostname, String message) {
		if (type == brain.JOIN) {
			joiners.put(sender, sender);
			if (bouncers.get(sender) != null) {
				// warn the bouncer
				brain.sendRatedAction("doesn't like things that bounce (sit still " + sender + ")");
			}
			return true;
		}
		if (type == brain.PART) {
			if (joiners.get(sender) != null) {
				// lamer alert!!!!!
				if (bouncers.get(sender) == null) {
					bouncers.put(sender, new Bouncer(sender));
					System.out.println("New bouncer " + sender);
				} else {
					// this is a repeat offender
					System.out.println("Repeat bouncer " + sender);
					int strikes = ((Bouncer) bouncers.get(sender)).bounce();
					System.out.print("Bounces that count = ");
					System.out.println(strikes);
					if (strikes == 3) {
						brain.banKick(hostname, login, sender, "has eaten you for bouncing 3 times in 15 minutes (sort your connection out!)");
						brain.sendPMAction(sender, "has eaten you for bouncing 3 times in 15 minutes (sort your connection out!)");
						brain.sendAction("has eaten the bouncy thing");
						bouncers.remove(sender);
					}
				}

				joiners.remove(sender);
			} else {
				bouncers.remove(sender);
				System.out.println("Non instant part was ignored: " + sender);
			}
			return true;
		} else if (type != brain.MP) {
			if (joiners.get(sender) != null) {
				// first message from this user
				String killMsg = null;
				String warnMsg = "";
				if ((message.toLowerCase().matches("!list.*$"))) {
					killMsg = "Wicket has eaten you for acting like a !numpty";
					warnMsg = "hisses at " + sender + " for acting like a !numpty";
				}
				if ((message.toLowerCase().matches("^.*tp:\\/.*$"))) {
					warnMsg = "hisses at " + sender + " for acting like a HTTP spammer";
					killMsg = "Wicket has eaten you for HTTP spamming";
				}
				if ((message.toLowerCase().matches("^.*outwar.com.*$"))) {
					warnMsg = "hisses at " + sender + " (make peace not outwar)";
					killMsg = "Wicket has eaten you (make peace not outwar)";

				}
				if ((message.toLowerCase().matches("^.*come.* #.*$")) || (message.toLowerCase().matches("^.*join.* #.*$"))) {
					warnMsg = "hisses at " + sender + " for looking like a #spammer";
					killMsg = "Wicket has eaten you (join #wicket-food)";
				}

				if (killMsg != null) {
					// first thing they said was a link - kill them
					if (brain.isOp(sender) || (brain.isWhite(sender))) {
						// dont hurt ops
						brain.sendRatedAction(warnMsg);
					} else {
						brain.banKick(null, null, sender, killMsg);
					}
				}
				joiners.remove(sender);
			} else {
				return false;
			}
		}

		return false;
	}

	public String getDescription() {
		return "Gatekeeper plugin - stops lamers bouncing and join spamming";
	}

	public String getName() {
		return "gatekeeper";
	}

}
